library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity regfile is
  port ( RegA, RegB, RegW : in integer range 0 to 31;
         rst,clk,RegWrite: in std_logic;
         Datow: in Std_logic_vector(31 downto 0);
         
         A,B: out std_logic_vector(31 downto 0)
         );
end regfile;

architecture beh of regfile is
  
type RFILE is array( 0 to 31) of std_logic_vector(31 downto 0);
 signal Reg: RFILE;
begin
 A<= Reg(RegA) after 2 ns;
 B<= Reg(RegB) after 2 ns;
 
 process(rst,clk)
  begin
   if rst= '1' then
     for i in 0 to 31 loop
       Reg(i) <= (Reg(i)'range => '0');
       --Reg(i) <= conv_std_logic_vector(0,32);
     end loop;
   elsif clk'event and clk='1' and RegWrite ='1' then
    Reg(RegW) <= DatoW;
   end if;
 end process;
 end beh;
