library ieee;
use ieee.std_logic_1164.all;

entity tbg is
end tbg;

architecture tbb of tbg is
 
component  SRAM is
  generic ( dadd: integer;
            dimw: integer);
            
   port ( addr : in integer range 0 to 2**dadd-1;
         cs,rw,oe: in std_logic;
         din: in std_logic_vector(dimw-1 downto 0);
         dout: out std_logic_vector(dimw-1 downto 0);
         ready: out std_logic);
end component;

signal addr: integer range 0 to 2**16-1;
signal cs,rw,oe,ready: std_logic;
signal din,dout: std_logic_vector(31 downto 0);

begin
   
  dut: SRAM generic map (16,32)
            port map (addr,cs,rw,oe,din,dout,ready);
  
  process
    variable ind: integer range 0 to 2**16-1:=0;
    begin
      cs<= '1';
      oe<= '1';
      addr <= ind;
      din <= "00000000000000000000000000101010";
      wait for 2 ns;
      cs <= '0';
      rw <= '0';
      wait for 2 ns;
      oe <= '0';
      wait until ready='1';
      wait for 2 ns;
      cs<= '1';
      oe<= '1';
      addr <= ind+1;
      din <= "00000000000000000000000110101010";
      wait for 2 ns;
      cs <= '0';
      rw <= '0';
      wait for 2 ns;
      oe <= '0';
      wait until ready='1';
      wait for 2 ns;
      cs<= '1';
      oe<= '1';
      addr <= ind;
      wait for 2 ns;
      cs <= '0';
      rw <= '1';
      wait for 2 ns;
      oe <= '0';
      wait until ready='1';
      wait for 2 ns;
      cs<= '1';
      oe<= '1';
      addr <= ind+1;
      wait for 2 ns;
      cs <= '0';
      rw <= '1';
      wait for 2 ns;
      oe <= '0';
      wait until ready='1';
      wait for 2 ns;
      ind:=ind+100;
    end process;
  end tbb;